/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar

import de.steamwar.plugins.configurePlugins
import de.steamwar.routes.configureRoutes
import de.steamwar.sql.SteamwarUser
import io.ktor.server.application.*
import io.ktor.server.engine.*
import io.ktor.server.netty.*
import kotlinx.serialization.ExperimentalSerializationApi
import kotlinx.serialization.Serializable
import kotlinx.serialization.json.Json
import kotlinx.serialization.json.decodeFromStream
import java.io.File

@Serializable
data class ResponseError(val error: String, val code: String = error)

@Serializable
data class Config(val giteaToken: String, val sessionSignSecret: String, val sessionEncryptSecret: String)

@OptIn(ExperimentalSerializationApi::class)
val config = Json.decodeFromStream<Config>(File("config.json").inputStream())

fun main() {
    Thread {
        while (true) {
            Thread.sleep(1000 * 10)
            SteamwarUser.clear()
        }
    }.start()
    embeddedServer(Netty, port = 1337, host = "127.0.0.1", module = Application::module)
        .start(wait = true)
}

fun Application.module() {
    configurePlugins()
    configureRoutes()
}
